﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using RTLabelPrinterWinSDK;

namespace RTLabelPrinterSDK_Example
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private static int DPI_PRINTER = 203;
        private static float PT_CONSTANT = DPI_PRINTER / 72;  // 1pt = (DPI_PRINTER/72) px

        private void PrintHelvetica()
        {
            string ttfPath = Application.StartupPath + "\\Helvetica.ttf";          
             PrivateFontCollection pfc = new PrivateFontCollection();
             pfc.AddFontFile(ttfPath);

            int paperWidth = 50; //50 mm
            int paperHeight = 150; //150mm 

            int barHDot = 2;
            int barX = 2;
            int barY = 2;
            int rectWidth = paperWidth * 8 - 2 - barHDot * 2;
            int rectHeight = (paperHeight * 8 - barHDot * 2) - 4;
            byte[] barTop = Cmd.GetBarPrintData(barX, barY, rectWidth, barHDot);
            byte[] barBottom = Cmd.GetBarPrintData(barX, barY + rectHeight, rectWidth, barHDot);
            byte[] barLeft = Cmd.GetBarPrintData(barX, barY, barHDot, rectHeight);
            byte[] barRight = Cmd.GetBarPrintData(barX+rectWidth, barY, barHDot, rectHeight);

            int lineX = 8;
            int lineY = 64;
            int lineW = paperWidth * 8 - 2 * lineX;
            byte[] barLine1 = Cmd.GetBarPrintData(lineX, lineY, lineW, barHDot);
            lineY = lineY * 2 + 2;
            byte[] barLine2 = Cmd.GetBarPrintData(lineX, lineY, lineW, barHDot * 6);
            lineY += 72;
            byte[] barLine3 = Cmd.GetBarPrintData(lineX, lineY, lineW, barHDot * 3);

            int lineDistance = 32;
            int i = 1;
            byte[] barLine4 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine5 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine6 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine7 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine8 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine9 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine10 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine11 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine12 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            lineY += lineDistance * (i++);
            byte[] barLine13 = Cmd.GetBarPrintData(lineX, lineY, lineW, barHDot);

            lineY += lineDistance + 4;
            byte[] barLine14 = Cmd.GetBarPrintData(lineX, lineY, lineW, barHDot*6);

            lineY += barHDot * 6;
            i = 1;
            byte[] barLine15 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine16 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine17 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot);
            byte[] barLine18 = Cmd.GetBarPrintData(lineX, lineY + lineDistance * (i++), lineW, barHDot*3);


            Font f = new Font(pfc.Families[0], 18 * PT_CONSTANT, FontStyle.Bold);
            

            int bitmapWidth = paperWidth * 8 - barHDot * 2 - barX;
            Bitmap bmp1 = new Bitmap(bitmapWidth, f.Height+4, PixelFormat.Format32bppRgb); 
            Graphics gBmp = Graphics.FromImage(bmp1);

            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Nutrition Facts", f, Brushes.Black, new PointF(0f, 0f));

            Font f8Regular = new Font(pfc.Families[0], 8 * PT_CONSTANT, FontStyle.Regular);
            Bitmap bmp2 = new Bitmap(bitmapWidth, f8Regular.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp2);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("2 servings per container", f8Regular, Brushes.Black, new PointF(0f, 0f));

            Font f8Bold = new Font(pfc.Families[0], 8 * PT_CONSTANT, FontStyle.Bold);
            Bitmap bmp3 = new Bitmap(bitmapWidth, f8Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp3);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Serving size     1 cup(140g)", f8Bold, Brushes.Black, new PointF(0f, 0f));

            f = new Font(pfc.Families[0], 12 * PT_CONSTANT, FontStyle.Bold);
            Bitmap bmp4 = new Bitmap(bitmapWidth, (f.Height + 4)*2, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp4);
            gBmp.Clear(System.Drawing.Color.White);
            
            gBmp.DrawString("Calories", f, Brushes.Black, new PointF(0f, 18f));
            gBmp.DrawString("160", f, Brushes.Black, new PointF(300f, 4f));
            gBmp.DrawString("Amount per serving", f8Regular, Brushes.Black, new PointF(0f, 0f));

            
            Font f10Bold = new Font(pfc.Families[0], 10 * PT_CONSTANT, FontStyle.Bold);
            Bitmap bmp5 = new Bitmap(bitmapWidth, f.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp5);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("% Daily Value*", f10Bold, Brushes.Black, new PointF(180f, 0f));

        
            Bitmap bmp6 = new Bitmap(bitmapWidth, f.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp6);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Total Fat", f10Bold, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("10%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            gBmp.DrawString("8g", f8Regular, Brushes.Black, new PointF(140f, 0f));

            Font f10Regular = new Font(pfc.Families[0], 10 * PT_CONSTANT, FontStyle.Regular);
            Bitmap bmp7 = new Bitmap(bitmapWidth, f10Regular.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp7);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Saturated Fat 3g", f10Regular, Brushes.Black, new PointF(0f, 0f));

            gBmp.DrawString("15%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp8 = new Bitmap(bitmapWidth, f.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp8);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Trans Fat 0g", f10Regular, Brushes.Black, new PointF(0f, 0f));

            Bitmap bmp9 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp9);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Cholesterol", f10Bold, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("0mg", f10Regular, Brushes.Black, new PointF(0f, 120f));
            gBmp.DrawString("0%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp10 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp10);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Sodium", f10Bold, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("60mg", f10Regular, Brushes.Black, new PointF(0f, 100f));
            gBmp.DrawString("3%", f8Bold, Brushes.Black, new PointF(320f, 0f));


            Bitmap bmp11 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp11);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Total Carbohydrate", f10Bold, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("21g", f10Regular, Brushes.Black, new PointF(0f, 160f));
            gBmp.DrawString("8%", f8Bold, Brushes.Black, new PointF(320f, 0f));


            Bitmap bmp12 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp12);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Dietary Fiber 3g", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("11%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp13 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp13);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Total Sugars 15g", f10Regular, Brushes.Black, new PointF(0f, 0f));

            Bitmap bmp14 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp14);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Includes 5g Added Sugars", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("10%", f8Bold, Brushes.Black, new PointF(320f, 0f));


            Bitmap bmp15 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp15);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Protein", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("3g", f10Regular, Brushes.Black, new PointF(100f, 0f));

            Bitmap bmp16 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp16);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Vitamin D 5mcg", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("25%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp17 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp17);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Calcium 20mg", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("2%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp18 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp18);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Iron 1mg", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("6%", f8Bold, Brushes.Black, new PointF(320f, 0f));

            Bitmap bmp19 = new Bitmap(bitmapWidth, f10Bold.Height + 4, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp19);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("Potassium 230mg", f10Regular, Brushes.Black, new PointF(0f, 0f));
            gBmp.DrawString("4%", f8Bold, Brushes.Black, new PointF(320f, 0f));


            StringFormat sf = new StringFormat();
            sf.Alignment = StringAlignment.Near;
            sf.LineAlignment = StringAlignment.Near;
            RectangleF rec = new RectangleF(0, 0, bitmapWidth, f10Regular.Height*6);

            Bitmap bmp20 = new Bitmap(bitmapWidth, f10Regular.Height*6, PixelFormat.Format32bppRgb);
            gBmp = Graphics.FromImage(bmp20);
            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("*The % Daily Value tells you how much a nutrient in a serving of food contributes to a daily diet. 2000 calories a day is used for general nutrition advice.", 
                f10Regular, 
                Brushes.Black,
                rec,
                sf);

            LabelPrinterFactory factory = new LPFactory();
            Printer printer = factory.Create("Rongta RP4xx Series");//printer name is "Rongta RP4xx Series"

            byte[] header = Cmd.GetPrintCmdHeader(paperWidth, paperHeight, 0, 0, 3, 8, false, false);//paper width 50 mm paper height 150 mm start position 0 0  print speed 3 print density 8
            int bitmapX = barX + 2;
            int bitmapY = barY + 2;
            byte[] bitmapData1 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp1);
            bitmapY += 64;
            byte[] bitmapData2 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp2);


            bitmapY += 30;
            byte[] bitmapData3 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp3);

            bitmapY += 44;
            byte[] bitmapData4 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp4);

            bitmapY += lineDistance*2;
            byte[] bitmapData5 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp5);

            bitmapY += lineDistance;
            byte[] bitmapData6 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp6);

            bitmapY += lineDistance;
            byte[] bitmapData7 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp7);

            bitmapY += lineDistance;
            byte[] bitmapData8 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp8);

            bitmapY += lineDistance;
            byte[] bitmapData9 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp9);

            bitmapY += lineDistance;
            byte[] bitmapData10 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp10);

            bitmapY += lineDistance;
            byte[] bitmapData11 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp11);

            bitmapY += lineDistance;
            byte[] bitmapData12 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp12);

            bitmapY += lineDistance;
            byte[] bitmapData13 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp13);

            bitmapY += lineDistance;
            byte[] bitmapData14 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp14);

            bitmapY += lineDistance;
            byte[] bitmapData15 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp15);

            bitmapY += (lineDistance+12);
            byte[] bitmapData16 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp16);

            bitmapY += lineDistance;
            byte[] bitmapData17 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp17);

            bitmapY += lineDistance;
            byte[] bitmapData18 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp18);

            bitmapY += lineDistance;
            byte[] bitmapData19 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp19);

            bitmapY += (lineDistance+12);
            byte[] bitmapData20 = Cmd.GetBitmapPrintData(bitmapX, bitmapY, bmp20);


            byte[] qrCodeData = Cmd.GetQRCodePrintData(bitmapX + 128, bitmapY+32*6, 'M', 4, 0, "http://www.baidu.com");
            byte[] barCodeData = Cmd.GetBARCodePrintData(bitmapX+52, bitmapY+32*10, "128M", 60, true, 0, 1, 5, "2232234459234567812");

            byte[] printCopyData = Cmd.GetPrintCopyCmd(1);

            Cmd myCmd = new Cmd();
            myCmd.Clear(); 

            myCmd.Append(header);

            myCmd.Append(barTop);
            myCmd.Append(barBottom);
            myCmd.Append(barLeft);
            myCmd.Append(barRight);

            myCmd.Append(barLine1);
            myCmd.Append(barLine2);
            myCmd.Append(barLine3);
            myCmd.Append(barLine4);
            myCmd.Append(barLine5);
            myCmd.Append(barLine6);
            myCmd.Append(barLine7);
            myCmd.Append(barLine8);
            myCmd.Append(barLine9);
            myCmd.Append(barLine10);
            myCmd.Append(barLine11);
            myCmd.Append(barLine12);
            myCmd.Append(barLine13);
            myCmd.Append(barLine14);
            myCmd.Append(barLine15);
            myCmd.Append(barLine16);
            myCmd.Append(barLine17);
            myCmd.Append(barLine18);

            myCmd.Append(bitmapData1);
            myCmd.Append(bitmapData2);
            myCmd.Append(bitmapData3);
            myCmd.Append(bitmapData4);
            myCmd.Append(bitmapData5);
            myCmd.Append(bitmapData6);
            myCmd.Append(bitmapData7);
            myCmd.Append(bitmapData8);
            myCmd.Append(bitmapData9);
            myCmd.Append(bitmapData10);
            myCmd.Append(bitmapData11);
            myCmd.Append(bitmapData12);
            myCmd.Append(bitmapData13);
            myCmd.Append(bitmapData14);
            myCmd.Append(bitmapData15);
            myCmd.Append(bitmapData16);
            myCmd.Append(bitmapData17);
            myCmd.Append(bitmapData18);
            myCmd.Append(bitmapData19);
            myCmd.Append(bitmapData20);

            myCmd.Append(qrCodeData);
            myCmd.Append(barCodeData);

            myCmd.Append(printCopyData);

            printer.Open();

            byte[] cmd = myCmd.GetAppendCmd();
            uint writeLen = (uint)cmd.Length;

            printer.Write(cmd, ref writeLen);

            printer.Close();
        }


        private void PrintChinese()
        {
            Font f = new Font("宋体", 16 * PT_CONSTANT, FontStyle.Regular);

            Bitmap bmp = new Bitmap(50 * 8, f.Height + 6, PixelFormat.Format32bppRgb); //width = 50 mm  height = f.Height+6 dots
            Graphics gBmp = Graphics.FromImage(bmp);

            gBmp.Clear(System.Drawing.Color.White);
            gBmp.DrawString("好吃的水果", f, Brushes.Black, new PointF(2f, 2f));

            Bitmap bmp1 = new Bitmap(60, f.Height + 6, PixelFormat.Format32bppRgb); //width = 40 dots  height = f.Height+6 dots
            Graphics gBmp1 = Graphics.FromImage(bmp1);

            gBmp1.Clear(System.Drawing.Color.White);
            gBmp1.DrawString("好", f, Brushes.Black, new PointF(2f, 2f));

            Bitmap bmp2 = new Bitmap(60, f.Height + 6, PixelFormat.Format32bppRgb); //width = 40 dots  height = f.Height+6 dots
            Graphics gBmp2 = Graphics.FromImage(bmp2);

            gBmp2.Clear(System.Drawing.Color.White);
            gBmp2.DrawString("吃", f, Brushes.Black, new PointF(2f, 2f));

            int barHDot = 3;
            byte[] barTop = Cmd.GetBarPrintData(1, 1, 50 * 8 - 2, barHDot);
            byte[] barBottom = Cmd.GetBarPrintData(1, 60 * 8 - barHDot - 1, 50 * 8 - 2, barHDot);
            byte[] barLeft = Cmd.GetBarPrintData(1, 1, barHDot, 60 * 8 - barHDot - 1);
            byte[] barRight = Cmd.GetBarPrintData(50 * 8 - barHDot - 1, 1, barHDot, 60 * 8 - barHDot - 1);

            int lineX = 8;
            int line1Y = 32+100;
            int lineW = 50 * 8 - 2 * lineX;
            byte[] barLine1 = Cmd.GetBarPrintData(lineX, line1Y, lineW, barHDot);
            byte[] barLine2 = Cmd.GetBarPrintData(lineX, line1Y + 40, lineW, barHDot * 2);
            byte[] barLine3 = Cmd.GetBarPrintData(lineX, line1Y + 40 + 45, lineW, barHDot * 2);

            int lineDistance = 36;
            int i = 1;
            byte[] barLine4 = Cmd.GetBarPrintData(lineX, line1Y + 40 + 45 + lineDistance * (i++), lineW, barHDot);

            LabelPrinterFactory factory = new LPFactory();
            Printer printer = factory.Create("Rongta RP4xx Series");//打印机名称为"Rongta RP4xx Series"

            byte[] header = Cmd.GetPrintCmdHeader(50, 60, 0, 0, 3, 8, false, false);//纸张宽度 50 mm  纸张高度 60 mm 起始坐标 0 0 打印速度3 打印浓度 8
            byte[] bitmapData1 = Cmd.GetBitmapPrintData(4, 20, bmp);//打印的位图数据
            byte[] printCopyData = Cmd.GetPrintCopyCmd(1);//打印份数 1份

            byte[] bitmapData2 = Cmd.GetBitmapPrintData(320, 24, bmp1);//打印的位图数据
            byte[] bitmapData3 = Cmd.GetBitmapPrintData(320, 64, bmp2);//打印的位图数据

            printer.Open();//打开打印机

            uint writeLen = (uint)header.Length;
            printer.Write(header, ref writeLen);

            writeLen = (uint)bitmapData1.Length;
            printer.Write(bitmapData1, ref writeLen);

            writeLen = (uint)bitmapData2.Length;
            printer.Write(bitmapData2, ref writeLen);

            writeLen = (uint)bitmapData3.Length;
            printer.Write(bitmapData3, ref writeLen);

            writeLen = (uint)barTop.Length;
            printer.Write(barTop, ref writeLen);

            writeLen = (uint)barBottom.Length;
            printer.Write(barBottom, ref writeLen);

            writeLen = (uint)barLeft.Length;
            printer.Write(barLeft, ref writeLen);

            writeLen = (uint)barRight.Length;
            printer.Write(barRight, ref writeLen);

            writeLen = (uint)barLine1.Length;
            printer.Write(barLine1, ref writeLen);

            writeLen = (uint)barLine2.Length;
            printer.Write(barLine2, ref writeLen);

            writeLen = (uint)barLine3.Length;
            printer.Write(barLine3, ref writeLen);

            writeLen = (uint)barLine4.Length;
            printer.Write(barLine4, ref writeLen);

            writeLen = (uint)printCopyData.Length;
            printer.Write(printCopyData, ref writeLen);
            printer.Close();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            PrintHelvetica();
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            PrintChinese();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            String str = "再打印一行文本";
            byte[] bb = Encoding.Default.GetBytes(str);
            int b = 0;
        }
    }
}
